<template>
  <v-form ref="form" v-model="valid" lazy-validation>
    <v-row wrap>
      <template v-for="(field, index) in formFields">
        <v-col
          :key="'field' + index"
          :cols="field.cols !== undefined ? field.cols : '12'"
        >
          <component
            :name="field.id"
            v-bind="field.props"
            v-on="field.events"
            :is="field.type"
            v-model="computedValue[field.id]"
            :ref="field.id"
            @change="save(computedValue)"
            @input="save(computedValue)"
          />
        </v-col>
      </template>
    </v-row>
  </v-form>
</template>

<script>
import DateInput from "./Fields/DateInput.vue";
import TimeInput from "./Fields/TimeInput.vue";
import RelationInput from "./Fields/RelationInput.vue";
import UploadInput from "./Fields/UploadInput.vue";
import flatten from "flat";
import {
  VTextField,
  VAutocomplete,
  VCombobox,
  VColorPicker,
  VSelect,
  VTextarea,
  VCheckbox,
  VRadio,
  VRadioGroup,
  VSlider,
  VSwitch,
  VRating
} from "vuetify/lib";
/**
 * Form Builder
 * @displayName Form Builder
 * @example ./examples/Form.md
 */
export default {
  components: {
    DateInput,
    TimeInput,
    RelationInput,
    UploadInput,
    VTextField,
    VAutocomplete,
    VCombobox,
    VColorPicker,
    VSelect,
    VTextarea,
    VCheckbox,
    VRadio,
    VRadioGroup,
    VSlider,
    VSwitch,
    VRating
  },
  name: "FormBuilder",
  props: {
    /**
     * Value
     */
    value: {
      type: Object,
      default: () => ({})
    },
    /**
     *
     * the fields that are going to be used in the form
     *  {
     *   id: String,
     *   type: String,
     *   props: Object,
     *   events: Object
     * },
     *
     *- **type**: the field type, see vuetify inputs
     *
     *- **props**:  vuetify/html field attributes
     *
     *- **events**: vuetify/html field events
     */

    fields: Array
  },
  data() {
    return {
      valid: true
    };
  },
  computed: {
    /**
     * Manage fields display depending on the mode flag (edit/create)
     * FIXME: think of an alternative solution
     */
    formFields() {
      return this.fields.filter(field => {
        return (
          (Object.keys(this.value).length === 0 && !field.disableOnCreate) ||
          (Object.keys(this.value).length > 0 && !field.disableOnEdit)
        );
      });
    },
    computedValue: {
      get() {
        return flatten({ ...this.value }, { safe: true });
      },
      set(v) {
        this.save(v);
      }
    }
  },
  methods: {
    save(v) {
      const tempVar = flatten.unflatten({ ...v }, { safe: true });
      this.$emit("input", tempVar);
    },
    validate() {
      const isValid = this.$refs.form.validate();
      return isValid;
    },
    async uploadFiles() {
      const uploadFields = this.fields.filter(
        field => field.type === "upload-input"
      );
      const uploadPromises = uploadFields.map(field =>
        this.$refs[field.id][0].process()
      );
      await Promise.all(uploadPromises);
      return true;
    },
    reset() {
      this.$refs.form.reset();
      const uploadFields = this.fields.filter(
        field => field.type === "upload-input"
      );
      uploadFields.map(field => this.$refs[field.id][0].reset());
      return true;
    }
  }
};
</script>
